<template>
	<v-card class="mx-auto" max-width="600">
		<v-container>
			<v-row>
				<v-col cols="12" sm="6" v-for="item of scholarships" :key="item.name">
					<!-- Si la fecha limite es mayor a 0 se habilitan las opciones -->
					<div v-if="limitDay > 0">
						<!-- card para no solicitar mas de una beca en el mismo periodo -->
						<v-card
							v-if="period === periodLastScholarship"
							outlined
							:disabled="
							period === periodLastScholarship &&
							lastScholarship === item.name
								? false
								: true
						"
						>
							<v-card color="#c51f2f" height="60">
								<v-card-text>
									<p class="text-center white--text title">{{ item.name }}</p>
								</v-card-text>
							</v-card>
							<v-card-text>
								<v-row>
									<v-col cols="12" class="pb-0 pt-0">
										<v-img src="https://picsum.photos/510/300?random" aspect-ratio="2"></v-img>
									</v-col>
									<!-- Botones -->
									<v-col cols="12" class="text-center pa-0">
										<v-row>
											<v-col>
												<v-btn
													outlined
													rounded
													block
													color="#c51f2f"
													:to="{
													name: 'MyDocuments',
													params: {
														typeScholarship:
															item.route
													}
												}"
												>Mis documentos</v-btn>
											</v-col>
										</v-row>
									</v-col>
								</v-row>
							</v-card-text>
						</v-card>

						<!-- card que habilita todas las opciones de beca -->
						<v-card v-else outlined>
							<v-card color="#c51f2f" height="60">
								<v-card-text>
									<p class="text-center white--text title">{{ item.name }}</p>
								</v-card-text>
							</v-card>
							<v-card-text>
								<v-row>
									<v-col cols="12" class="pb-0 pt-0">
										<v-img src="https://picsum.photos/510/300?random" aspect-ratio="2"></v-img>
									</v-col>
									<!-- Botones -->
									<v-col cols="12" class="text-center pa-0">
										<v-row>
											<v-col v-if="
												lastScholarship !== item.name
											">
												<v-btn
													rounded
													outlined
													block
													color="green"
													:to="{
													name: 'NewScholarship',
													params: {
														typeNewScholarship:
															item.route
													}
												}"
												>Solicitar beca</v-btn>
											</v-col>
											<v-col v-else>
												<v-btn
													rounded
													outlined
													block
													color="green"
													:to="{
													name:
														'RenovationScholarship',
													params: {
														typeRenovationScholarship:
															item.route
													}
												}"
												>Solicitar beca</v-btn>
											</v-col>
										</v-row>
									</v-col>
								</v-row>
							</v-card-text>
						</v-card>
					</div>
					<!-- Si la fecha limite es menor a 0 se deshabilita todo -->
					<div v-else>
						<v-card v-if="period === periodLastScholarship" outlined disabled>
							<v-card color="#c51f2f" height="60">
								<v-card-text>
									<p class="text-center white--text title">{{ item.name }}</p>
								</v-card-text>
							</v-card>
							<v-card-text>
								<v-row>
									<v-col cols="12" class="pb-0 pt-0">
										<v-img src="https://picsum.photos/510/300?random" aspect-ratio="2"></v-img>
									</v-col>
									<!-- Botones -->
									<v-col cols="12" class="text-center pa-0">
										<v-row>
											<v-col>
												<v-btn
													outlined
													rounded
													block
													color="#c51f2f"
													:to="{
													name: 'MyDocuments',
													params: {
														typeScholarship:
															item.route
													}
												}"
												>Mis documentos</v-btn>
											</v-col>
										</v-row>
									</v-col>
								</v-row>
							</v-card-text>
						</v-card>

						<!-- card que habilita todas las opciones de beca -->
						<v-card v-else outlined disabled>
							<v-card color="#c51f2f" height="60">
								<v-card-text>
									<p class="text-center white--text title">{{ item.name }}</p>
								</v-card-text>
							</v-card>
							<v-card-text>
								<v-row>
									<v-col cols="12" class="pb-0 pt-0">
										<v-img src="https://picsum.photos/510/300?random" aspect-ratio="2"></v-img>
									</v-col>
									<!-- Botones -->
									<v-col cols="12" class="text-center pa-0">
										<v-row>
											<v-col v-if="
												lastScholarship !== item.name
											">
												<v-btn
													rounded
													outlined
													block
													color="green"
													:to="{
													name: 'NewScholarship',
													params: {
														typeNewScholarship:
															item.route
													}
												}"
												>Solicitar beca</v-btn>
											</v-col>
											<v-col v-else>
												<v-btn
													rounded
													outlined
													block
													color="green"
													:to="{
													name:
														'RenovationScholarship',
													params: {
														typeRenovationScholarship:
															item.route
													}
												}"
												>Solicitar beca</v-btn>
											</v-col>
										</v-row>
									</v-col>
								</v-row>
							</v-card-text>
						</v-card>
					</div>
				</v-col>
			</v-row>
		</v-container>
	</v-card>
</template>
<script>
import gql from "graphql-tag";
import { mapMutations, mapState } from "vuex";
import EventBus from "../../bus";

export default {
	name: "TypesScholarships",
	data: () => ({
		lastScholarship: "",
		periodLastScholarship: "",
		scholarships: [
			{
				name: "Talento especial",
				route: "talento-especial"
			},
			{
				name: "Excelencia académica",
				route: "excelencia-académica"
			},
			{
				name: "Mejora académica",
				route: "mejora-académica"
			},
			{ name: "Labsol", route: "labsol" }
		],
		date: new Date(),
		haveDocuments: false
	}),
	computed: {
		...mapState(["userData", "limitDay"]),

		// Regresa el periodo actual
		period() {
			if (this.date.getMonth() + 1 <= 7) {
				return `Enero - Junio ${this.date.getFullYear()}`;
			} else {
				return `Agosto - Diciembre ${this.date.getFullYear()}`;
			}
		}
	},
	methods: {
		...mapMutations(["saveUserData"]),

		//Obtiene los datos para condicionar los formularios de documentos
		async getLastScholarship() {
			this.saveUserData();
			try {
				const { data } = await this.$apollo.query({
					query: gql`
						query($curp: String!) {
							getLastScholarship(curp: $curp) {
								scholarship
								period
							}
						}
					`,
					variables: {
						curp: this.userData.curp
					}
				});
				this.lastScholarship = data.getLastScholarship.scholarship;
				this.periodLastScholarship = data.getLastScholarship.period;
			} catch (error) {}
		}
	},
	created() {
		this.getLastScholarship();
	}
};
</script>
